
#line 1 "ptree.ch"
/*************************************************************************/
#line 1 "ptree.ch"
/*                                                                       */
#line 1 "ptree.ch"
/*        Produced by Metachop version 2.0  -    1989-1995               */
#line 1 "ptree.ch"
/*     Tree      Meta     Chopper      developped    by                  */
#line 1 "ptree.ch"
/*                  Eric Lavillonniere                                   */
#line 1 "ptree.ch"
/*                                                                       */
#line 1 "ptree.ch"
/*************************************************************************/
#line 1 "ptree.ch"
#line 1 "ptree.ch"
#include "token.h"
#line 1 "ptree.ch"
#define decomp decomp_metachop
#line 1 "ptree.ch"
#line 1 "ptree.ch"
#ifndef for_elem
#line 1 "ptree.ch"
#line 1 "ptree.ch"
#define for_elem _for_elem
#line 1 "ptree.ch"
#endif
#ifdef INCONNU
#line 1 "ptree.ch"
#line 1 "ptree.ch"
PTREE   for_elem ;
#line 1 "ptree.ch"
#line 1 "ptree.ch"
#endif
#if MOST_RECENT_STL
#line 1 "ptree.ch"
#line 4 "ptree.ch"
#include <stack>
#line 4 "ptree.ch"
#line 5 "ptree.ch"
#include <vector>
#line 5 "ptree.ch"
#else 
#include <stack.h>
#include <vector.h>
#endif

#line 11 "ptree.ch"
#line 11 "ptree.ch"
static  int GetNumber ( const PTREE &tree )
#line 11 "ptree.ch"
{
#line 11 "ptree.ch"
#line 11 "ptree.ch"
    int _nextVal ;
#line 11 "ptree.ch"
#line 13 "ptree.ch"
    return APPLY_CLASS(tree, TreeClass, Type());
#line 13 "ptree.ch"
#line 14 "ptree.ch"
#line 14 "ptree.ch"
#line 14 "ptree.ch"
}
#line 14 "ptree.ch"

#include "token.h"

#line 21 "ptree.ch"
#line 21 "ptree.ch"
void PTREE::EncodeClass ( const PTREE &tree, EString &string )
#line 21 "ptree.ch"
{
#line 21 "ptree.ch"
#line 21 "ptree.ch"
    int _nextVal ;
#line 21 "ptree.ch"
#line 24 "ptree.ch"
    char    *thePt ;
#line 24 "ptree.ch"
#line 26 "ptree.ch"
    CoarseEncodeInt(GetNumber(tree), string);
#line 26 "ptree.ch"
#line 27 "ptree.ch"
    thePt = (char *)(tree.Value());
#line 27 "ptree.ch"
#line 28 "ptree.ch"
    CoarseEncodeInt(strlen(thePt), string);
#line 28 "ptree.ch"
#line 29 "ptree.ch"
    string += thePt ;
#line 29 "ptree.ch"
#line 30 "ptree.ch"
    return ;
#line 30 "ptree.ch"
#line 31 "ptree.ch"
#line 31 "ptree.ch"
#line 31 "ptree.ch"
}
#line 31 "ptree.ch"

#line 36 "ptree.ch"
#line 36 "ptree.ch"
void PTREE::CoarseEncode ( PTREE tree, EString &string )
#line 36 "ptree.ch"
{
#line 36 "ptree.ch"
#line 36 "ptree.ch"
    int _nextVal ;
#line 36 "ptree.ch"
#line 40 "ptree.ch"
    int arity ;
#line 40 "ptree.ch"
#line 41 "ptree.ch"
    int nbNode ;
#line 41 "ptree.ch"
#line 42 "ptree.ch"
    char    *thePt ;
#line 42 "ptree.ch"
#line 44 "ptree.ch"
start : 
#line 44 "ptree.ch"
#line 45 "ptree.ch"
    if ( !tree ) {
#line 45 "ptree.ch"
#line 46 "ptree.ch"
                    string += (char) -1 ;
#line 46 "ptree.ch"
#line 47 "ptree.ch"
                    return ;
#line 47 "ptree.ch"
#line 48 "ptree.ch"
#line 48 "ptree.ch"
#line 48 "ptree.ch"
                   }
#line 48 "ptree.ch"
#line 49 "ptree.ch"
    switch ( tree.NumberTree() ) {
#line 49 "ptree.ch"
#line 50 "ptree.ch"
        case TERM_TREE : 
#line 50 "ptree.ch"
#line 51 "ptree.ch"
            string += '\1';
#line 51 "ptree.ch"
#line 52 "ptree.ch"
            CoarseEncodeInt(TERM_TREE, string);
#line 52 "ptree.ch"
#line 53 "ptree.ch"
            CoarseEncode(tree [0], string);
#line 53 "ptree.ch"
#line 54 "ptree.ch"
            thePt = (char *)(tree.Value());
#line 54 "ptree.ch"
#line 55 "ptree.ch"
            CoarseEncodeInt(strlen(thePt), string);
#line 55 "ptree.ch"
#line 56 "ptree.ch"
            string += thePt ;
#line 56 "ptree.ch"
#line 57 "ptree.ch"
            return ;
#line 57 "ptree.ch"
#line 58 "ptree.ch"
        case CLASS_TREE : 
#line 58 "ptree.ch"
#line 59 "ptree.ch"
            string += '\1';
#line 59 "ptree.ch"
#line 60 "ptree.ch"
            CoarseEncodeInt(CLASS_TREE, string);
#line 60 "ptree.ch"
#line 61 "ptree.ch"
            CoarseEncode(tree [0], string);
#line 61 "ptree.ch"
#line 62 "ptree.ch"
            EncodeClass(tree, string);
#line 62 "ptree.ch"
#line 63 "ptree.ch"
            return ;
#line 63 "ptree.ch"
#line 64 "ptree.ch"
        case REF_TREE : 
#line 64 "ptree.ch"
#line 65 "ptree.ch"
            string += (char) -1 ;
#line 65 "ptree.ch"
#line 66 "ptree.ch"
            return ;
#line 66 "ptree.ch"
#line 68 "ptree.ch"
        default : 
#line 68 "ptree.ch"
#line 68 "ptree.ch"
            {
#line 68 "ptree.ch"
#line 71 "ptree.ch"
                arity = treearity(tree);
#line 71 "ptree.ch"
#line 72 "ptree.ch"
                string += (char)arity ;
#line 72 "ptree.ch"
#line 73 "ptree.ch"
                CoarseEncodeInt(tree.NumberTree(), string);
#line 73 "ptree.ch"
#line 74 "ptree.ch"
                CoarseEncode(tree [0], string);
#line 74 "ptree.ch"
#line 77 "ptree.ch"
                int indexSon ;
#line 77 "ptree.ch"
#line 78 "ptree.ch"
#line 78 "ptree.ch"
                for ( indexSon = 1 ; indexSon < arity ; indexSon++ ) {
#line 78 "ptree.ch"
#line 79 "ptree.ch"
CoarseEncode(tree [indexSon], string);
#line 79 "ptree.ch"
#line 80 "ptree.ch"
#line 80 "ptree.ch"
#line 80 "ptree.ch"
                                                                          }
#line 80 "ptree.ch"
#line 80 "ptree.ch"
#line 81 "ptree.ch"
                (tree=tree [arity]);
#line 81 "ptree.ch"
#line 81 "ptree.ch"
#line 82 "ptree.ch"
                goto start ;
#line 82 "ptree.ch"
#line 83 "ptree.ch"
#line 83 "ptree.ch"
#line 83 "ptree.ch"
            }
#line 83 "ptree.ch"
    }
#line 83 "ptree.ch"
#line 83 "ptree.ch"
#line 85 "ptree.ch"
#line 85 "ptree.ch"
#line 85 "ptree.ch"
}
#line 85 "ptree.ch"

#line 90 "ptree.ch"
#line 90 "ptree.ch"
PTREE PTREE::DecodeClass ( char *&string )
#line 90 "ptree.ch"
{
#line 90 "ptree.ch"
#line 90 "ptree.ch"
    int _nextVal ;
#line 90 "ptree.ch"
#line 94 "ptree.ch"
    PTREE   myTree ;
#line 94 "ptree.ch"
#line 94 "ptree.ch"
#line 95 "ptree.ch"
    PTREE   topTree ;
#line 95 "ptree.ch"
#line 95 "ptree.ch"
#line 96 "ptree.ch"
    int nbNode ;
#line 96 "ptree.ch"
#line 97 "ptree.ch"
    int length ;
#line 97 "ptree.ch"
#line 99 "ptree.ch"
    nbNode = CoarseDecodeInt(string);
#line 99 "ptree.ch"
#line 100 "ptree.ch"
    length = CoarseDecodeInt(string);
#line 100 "ptree.ch"
#line 101 "ptree.ch"
    (myTree=LMakeString(string, length));
#line 101 "ptree.ch"
#line 101 "ptree.ch"
#line 102 "ptree.ch"
    (topTree=PTREE(nbNode, 1));
#line 102 "ptree.ch"
#line 102 "ptree.ch"
#line 103 "ptree.ch"
    topTree.ReplaceTree(1, myTree);
#line 103 "ptree.ch"
#line 104 "ptree.ch"
    string += length ;
#line 104 "ptree.ch"
#line 105 "ptree.ch"
    return topTree ;
#line 105 "ptree.ch"
#line 106 "ptree.ch"
#line 106 "ptree.ch"
#line 106 "ptree.ch"
}
#line 106 "ptree.ch"

#line 111 "ptree.ch"

#line 111 "ptree.ch"
PTREE PTREE::CoarseDecode ( char *&string )
#line 111 "ptree.ch"
{
#line 111 "ptree.ch"
#line 111 "ptree.ch"
    int _nextVal ;
#line 111 "ptree.ch"
#line 114 "ptree.ch"
    char    arity ;
#line 114 "ptree.ch"
#line 115 "ptree.ch"
    PTREE   myTree ;
#line 115 "ptree.ch"
#line 115 "ptree.ch"
#line 116 "ptree.ch"
    int nbNode ;
#line 116 "ptree.ch"
#line 117 "ptree.ch"
    int length ;
#line 117 "ptree.ch"
#line 118 "ptree.ch"
    PTREE   comment ;
#line 118 "ptree.ch"
#line 118 "ptree.ch"
#line 119 "ptree.ch"
    int currPos = -1 ;
#line 119 "ptree.ch"
#line 120 "ptree.ch"
#if defined(NO_STACK)
#line 120 "ptree.ch"
#line 121 "ptree.ch"
    vector<PTREE>  treeStack ;
#line 121 "ptree.ch"
#elif defined(STL_3)
    stack<PTREE, vector<PTREE> >     treeStack ;
#else 
    stack<vector<PTREE> >     treeStack ;
#endif
#line 121 "ptree.ch"
#line 129 "ptree.ch"
start : 
#line 129 "ptree.ch"
#line 130 "ptree.ch"
    arity = *string++ ;
#line 130 "ptree.ch"
#line 133 "ptree.ch"
    if ( arity == (char) -1 ) 
#line 133 "ptree.ch"
#line 134 "ptree.ch"
        (myTree=(PTREE)0);
#line 134 "ptree.ch"
#line 134 "ptree.ch"
    else 
#line 135 "ptree.ch"
    {
#line 135 "ptree.ch"
#line 138 "ptree.ch"
        nbNode = CoarseDecodeInt(string);
#line 138 "ptree.ch"
#line 139 "ptree.ch"
        (comment=CoarseDecode(string));
#line 139 "ptree.ch"
#line 139 "ptree.ch"
#line 142 "ptree.ch"
        switch ( arity ) {
#line 142 "ptree.ch"
#line 143 "ptree.ch"
            case 1 : 
#line 143 "ptree.ch"
#line 144 "ptree.ch"
                switch ( nbNode ) {
#line 144 "ptree.ch"
#line 145 "ptree.ch"
                    case TERM_TREE : 
#line 145 "ptree.ch"
#line 146 "ptree.ch"
                        length = CoarseDecodeInt(string);
#line 146 "ptree.ch"
#line 147 "ptree.ch"
                        (myTree=LMakeString(string, length));
#line 147 "ptree.ch"
#line 147 "ptree.ch"
#line 148 "ptree.ch"
                        string += length ;
#line 148 "ptree.ch"
#line 149 "ptree.ch"
                        myTree.ReplaceTree(0, comment);
#line 149 "ptree.ch"
#line 150 "ptree.ch"
                        break ;
#line 150 "ptree.ch"
#line 151 "ptree.ch"
                    case CLASS_TREE : 
#line 151 "ptree.ch"
#line 152 "ptree.ch"
                        {
#line 152 "ptree.ch"
#line 153 "ptree.ch"
                            (myTree=DecodeClass(string));
#line 153 "ptree.ch"
#line 153 "ptree.ch"
#line 154 "ptree.ch"
                            myTree.ReplaceTree(0, comment);
#line 154 "ptree.ch"
#line 155 "ptree.ch"
#line 155 "ptree.ch"
#line 155 "ptree.ch"
                        }
#line 155 "ptree.ch"
#line 156 "ptree.ch"
                        break ;
#line 156 "ptree.ch"
#line 158 "ptree.ch"
                    default : 
#line 158 "ptree.ch"
#line 158 "ptree.ch"
                        (myTree=PTREE(nbNode, (int)arity));
#line 158 "ptree.ch"
#line 158 "ptree.ch"
#line 159 "ptree.ch"
                        myTree.ReplaceTree(1, CoarseDecode(string));
#line 159 "ptree.ch"
#line 160 "ptree.ch"
                        myTree.ReplaceTree(0, comment);
#line 160 "ptree.ch"
#line 161 "ptree.ch"
                        break ;
#line 161 "ptree.ch"
                }
#line 161 "ptree.ch"
#line 161 "ptree.ch"
#line 163 "ptree.ch"
                break ;
#line 163 "ptree.ch"
#line 165 "ptree.ch"
            default : 
#line 165 "ptree.ch"
#line 165 "ptree.ch"
                {
#line 165 "ptree.ch"
#line 168 "ptree.ch"
                    (myTree=PTREE(nbNode, (int)arity));
#line 168 "ptree.ch"
#line 168 "ptree.ch"
#line 169 "ptree.ch"
                    myTree.ReplaceTree(0, comment);
#line 169 "ptree.ch"
#line 172 "ptree.ch"
                    int indexSon ;
#line 172 "ptree.ch"
#line 173 "ptree.ch"
#line 173 "ptree.ch"
                    for ( indexSon = 1 ; indexSon < arity ; indexSon++ ) {
#line 173 "ptree.ch"
#line 174 "ptree.ch"
myTree.ReplaceTree(indexSon, CoarseDecode(string));
#line 174 "ptree.ch"
#line 175 "ptree.ch"
#line 175 "ptree.ch"
#line 175 "ptree.ch"
                                                                              }
#line 175 "ptree.ch"
#line 175 "ptree.ch"
#line 176 "ptree.ch"
#if defined(NO_STACK)
#line 176 "ptree.ch"
#line 177 "ptree.ch"
                    treeStack.reserve(currPos + 2);
#line 177 "ptree.ch"
#line 178 "ptree.ch"
                    treeStack [++currPos] = myTree ;
#line 178 "ptree.ch"
#else 
                    treeStack.push((const PTREE &)myTree);
#endif
#line 178 "ptree.ch"
#line 182 "ptree.ch"
                    goto start ;
#line 182 "ptree.ch"
#line 183 "ptree.ch"
#line 183 "ptree.ch"
#line 183 "ptree.ch"
                }
#line 183 "ptree.ch"
        }
#line 183 "ptree.ch"
#line 183 "ptree.ch"
#line 185 "ptree.ch"
#line 185 "ptree.ch"
#line 185 "ptree.ch"
    }
#line 185 "ptree.ch"
#line 187 "ptree.ch"
    while ( true ) {
#line 187 "ptree.ch"
#line 188 "ptree.ch"
#if !defined(NO_STACK)
#line 188 "ptree.ch"
#line 189 "ptree.ch"
                        currPos = treeStack.size();
#line 189 "ptree.ch"
#endif
#line 189 "ptree.ch"
#line 191 "ptree.ch"
                        if ( !currPos ) 
#line 191 "ptree.ch"
#line 191 "ptree.ch"
                            break ;
#line 191 "ptree.ch"
#line 192 "ptree.ch"
                        PTREE   topNode ;
#line 192 "ptree.ch"
#line 192 "ptree.ch"
#line 193 "ptree.ch"
#if defined(NO_STACK   )
#line 193 "ptree.ch"
#line 194 "ptree.ch"
                        (topNode=treeStack [currPos]);
#line 194 "ptree.ch"
#line 194 "ptree.ch"
#line 195 "ptree.ch"
                        currPos-- ;
#line 195 "ptree.ch"
#else 
                        (topNode=treeStack.top());
#line 195 "ptree.ch"
                        treeStack.pop();
#endif
#line 195 "ptree.ch"
#line 200 "ptree.ch"
                        topNode.ReplaceTree(topNode.TreeArity(), myTree);
#line 200 "ptree.ch"
#line 201 "ptree.ch"
                        (myTree=topNode);
#line 201 "ptree.ch"
#line 201 "ptree.ch"
#line 202 "ptree.ch"
#line 202 "ptree.ch"
#line 202 "ptree.ch"
                    }
#line 202 "ptree.ch"
#line 204 "ptree.ch"
    return myTree ;
#line 204 "ptree.ch"
#line 205 "ptree.ch"
#line 205 "ptree.ch"
#line 205 "ptree.ch"
}
#line 205 "ptree.ch"

#line 205 "ptree.ch"
/*Well done my boy */ 
#line 205 "ptree.ch"

